@******************************************************************@
@PROGRAM TO CALCULATE TESTS OF THE FIRST THREE ORDERS OF STOCHASTIC@
@DOMINANCE. BOTH STOLINE AND URY MULTIPLE COMPARISON AND KODDE AND @
@PALM OMNIBUS TESTS ARE CALCULATED AS IS THE PEARSON ANALOGUE TEST @
@FOR GENERAL DIFFERENCES IN DISTRIBUTION. THIS PROGRAM IS SET UP   @
@         FOR 10 (=KQ) EQUIPROBABLE INCOME CATEGORIES.             @
@******************************************************************@
@******************************************************************@
@ DATA INPUT OF NET AND MARKET INCOME (UNWEIGHTED BY FAMILY SIZE). @
@  IF ADULT EQUIVALENT SCALING IS TO BE USED THE SCALING FACTOR    @
@           SHOULD BE ENTERED AS ADULT79 AND ADULT89               @
@******************************************************************@
OUTPUT FILE = POLRWD1.TXT;OUTPUT ON;
"STRONG POLARIZATION RESULTS 1970 V 1995 POPULATION WEIGHTED DEPENDENT DISTRIBUTIONS";
LOAD PANDA[]=AEDATF.TXT;
NR=ROWS(PANDA) / 8;
PAN=RESHAPE(PANDA,NR,8);
@SELECT COMPARISON YEARS@
WW=PAN[.,1];YY=PAN[.,2];
WWPR=PAN[.,3];YYPR=POPR[.,4];
N79=ROWS(WW);N89=ROWS(YY);
N7989=N79+N89;
MXY=MEANC(WW|YY);
MX=MEANC(WW);MY=MEANC(YY);
X79=WW ./ MX;
X89=YY ./ MY;
X79PR=WWPR;X89PR=YYPR;
XXX=X79~X89;XN=N79;
KQA=4;
KQ=2*KQA;KQL=KQ-1;
RWT=RNDN(KQL,10000);
Q=ONES(KQA,1);O=ZEROS(KQA,KQA);
QQ=EYE(KQA);TAR=2;TAC=1;
DO WHILE TAR <= KQA;
QQ[TAR,TAC]=1;TAR=TAR+1;TAC=TAC+1;ENDO;
@*********************************************************@
@ the data is counted and sorted                          @
@*********************************************************@
KQ1=KQ+1;KQKQ=KQ^2;
P=ZEROS(KQ1,1);
PQ=ZEROS(KQKQ,1);
IA=1;
DO WHILE IA<= KQ;
IB=IA+1;
P[IB]=IA/KQ;
IA=IA+1;
ENDO;
XXD=XXX[.,1] | XXX[.,2];
XXPR=(X79PR * (0.5)) | (X89PR * (0.5));
XXDD=XXD~XXPR~CUMSUMC(ONES(N7989,1));
XDDD=SORTC(XXDD,1);XXXDD=CUMSUMC(XDDD[.,2])~XDDD[.,3];
XYZ = SORTC(XXXDD,2) ;
X=XYZ[1:XN,1];
Y=XYZ[XN+1:2*XN,1];
IA=1;IL=1;CHIS=0.0;
DO WHILE IL <= KQ;
JL=1;
IU=IL+1;
DO WHILE JL <=KQ;
JU=JL+1;
E=((X .GT P[IL]) .AND (X .LE P[IU])) .AND ((Y .GT P[JL]) .AND (Y .LE P[JU]));
PQ[IA]=SUMC(E)/XN;CHIS=CHIS+((PQ[IA]-KQKQ^(-1))^2)*KQKQ;
IA=IA+1;
JL=JL+1;
ENDO;
IL=IL+1;
ENDO;
                       @      @
@SET UP MARGINALISING, AGGREGATING AND COVARIANCE MATRICES@
                       @      @
DA=ONES(KQ,KQ);
DL=LOWMAT(DA);
VA=ONES(1,KQ);
D2=EYE(KQ*KQ);
XAYR=ONES(KQ,1);
D=(VA .*. DL)-(DL .*. VA);
OMEGA=D*(DIAGRV(D2,PQ)-PQ*PQ')*(D');
XXSORT=XDDD[.,1]~XYZ;
LET INDEX = 1;
DO WHILE INDEX <= KQ;
   BOB=MININDC(ABS(XXSORT[.,2]-P[INDEX,1]));
   XAYR[INDEX,1]= XXSORT[BOB,1];
   INDEX = INDEX+1;
ENDO;

"The cell frequencies for 1993 and 1994 are";(VA .*. DL)*PQ~(DL .*. VA)*PQ;
@*********************************************************@
@ the v vector is calculated - Anderson calls it DIFE     @
@*********************************************************@
IMI=(EYE(KQA)~O | O~-EYE(KQA));
V = IMI*D*PQ;
@*********************************************************@
@ calculation of the II matrix                            @
@*********************************************************@
III = LOWMAT(ONES(KQA,KQA));
II = III~O | O~III;
@*********************************************************@
@ this procedure creates XIYR = income range in each cell @
@*********************************************************@
XIYR = XAYR;
INDEX = 2;
DO WHILE INDEX <= KQ;
   XIYR[INDEX,1] = XAYR[INDEX,1] - XAYR[(INDEX-1),1];
   INDEX = INDEX+1;
ENDO;
@*********************************************************@
@ procedure for calculating IIF matrix                    @
@*********************************************************@
A1=Q*XIYR[1:KQA,1]'*QQ;A2=Q*XIYR[KQA+1:KQ,1]'QQ;
B = (LOWMAT(A1)~O | O~LOWMAT(A2));
IIF=DIAGRV(B,XIYR);
@*********************************************************@
@ the parameter estimates are calculated                  @
@*********************************************************@
IV = II*V;
IIV = IIF*II*V;
IIIV= IIF*IIF*II*V;
@*********************************************************@
@ the covariance matrices are calculated                  @
@ this calculates the OMEGA matrix                        @
@*********************************************************@
QIP=ONES(KQ,1)/KQ;
LET Q = 0.09 0.09 0.09 0.09 0.09 0.09 0.09 0.09 0.09 0.09;
LET PP = 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1;
PPP = -(PP*PP');
OMEGA = (EYE(KQ)/KQ)-QIP*QIP';
VARCOV = (N7989/(N79*N89))*OMEGA;
VARCOV1 = II*IMI*VARCOV*IMI'*II';
VARCOV2 = IIF*VARCOV1*IIF';
VARCOV3 = IIF*VARCOV2*IIF';
@*********************************************************@
@ the standard errors are calculated                      @
@*********************************************************@
SE1 = SQRT(DIAG(VARCOV1));
SE2 = SQRT(DIAG(VARCOV2));
SE3 = SQRT(DIAG(VARCOV3));
TEST1 = IV./SE1;
TEST2 = IIV./SE2;
TEST3 = IIIV./SE3;
FORMAT 10,5;
"The IV vector, std errors and test statistics are";IV~SE1~TEST1;
"The IIV vector, std errors and test statistics are";IIV~SE2~TEST2;
"The IIIV vector, std errors and test statistics are";IIIV~SE3~TEST3;

@*********************************************************@
@ this calculates the Pearson Analogue Test (PAT)         @
@*********************************************************@
PAT1 = IV'*INVSWP(VARCOV1)*IV;
"The Pearson Analogue Test (PAT) and degrees of freedom are ";PAT1;kql;
@*******************************************************************@
@ This component calculates the omnibus inequality test a<b and b<a @
@*******************************************************************@
@                 calculate test statistics WTI                     @
@*******************************************************************@
IVAB=IV~IIV~IIIV;
IVBA=-IVAB;
DAB = IVAB .<= 0.0;DBA = IVBA .<= 0.0;
DTAB = IVAB .* DAB;DTBA = IVBA .* DBA;
IDS=INV(IIF);IDT=INV(II);
WTJ=ZEROS(3,2);
WTJ[1,1] = DTAB[.,1]'*INVSWP(VARCOV1)*DTAB[.,1];
WTJ[2,1] = DTAB[.,2]'*INVSWP(VARCOV2)*DTAB[.,2];
WTJ[3,1] = DTAB[.,3]'*INVSWP(VARCOV3)*DTAB[.,3];
WTJ[1,2] = DTBA[.,1]'*INVSWP(VARCOV1)*DTBA[.,1];
WTJ[2,2] = DTBA[.,2]'*INVSWP(VARCOV2)*DTBA[.,2];
WTJ[3,2] = DTBA[.,3]'*INVSWP(VARCOV3)*DTBA[.,3];
@*******************************************************************@
@             calculate chi squared weights WEI                     @
@     note the k-1 x 10000 std normal random matrix RWT has been    @
@     calculated outside of this segment to save computing time     @
@*******************************************************************@
PWTI=ZEROS(3,2);WEI=ZEROS(KQ,3);DFT=SEQA(0,1,KQ);
OM1=II[1:KQL,1:KQL]*CHOL(OMEGA[1:KQL,1:KQL]);
OM2=IIF[1:KQL,1:KQL]*OM1';DS2=IIF*IIF;
OM3=DS2[1:KQL,1:KQL]*OM1';
RD= (OM1'*RWT) .<= 0.0;
WEI[.,1]=COUNTS(SUMC(RD),DFT)/10000;
RD=(OM2*RWT) .<= 0.0;
WEI[.,2]=COUNTS(SUMC(RD),DFT)/10000;
RD=(OM3*RWT) .<= 0.0;
WEI[.,3]=COUNTS(SUMC(RD),DFT)/10000;
CWAB=CDFCHIC(WTJ[.,1],DFT[2:KQ]');
CWBA=CDFCHIC(WTJ[.,2],DFT[2:KQ]');
IAM=1;
DO WHILE IAM <=3;
PWTI[IAM,1]=WEI[2:KQ,IAM]'*REV(CWAB[IAM,.]');
PWTI[IAM,2]=WEI[2:KQ,IAM]'*REV(CWBA[IAM,.]');
IAM = IAM + 1;
ENDO;
"The Wald Criteria for the composite hypotheses a v b and b v a are"
WTJ;
"The corresponding probabilities based upon simulated weights are"
PWTI;
END;



